org.apache.cassandra.db

## Class NativeCell

- java.lang.Object
- - org.apache.cassandra.db.AbstractCell
  - - org.apache.cassandra.db.AbstractNativeCell
    - - org.apache.cassandra.db.NativeCell

- All Implemented Interfaces:
    IMeasurableMemory, Cell, CellName, Composite, OnDiskAtom
  Direct Known Subclasses:
    NativeCounterCell, NativeDeletedCell, NativeExpiringCell

      public class NativeCell
      extends AbstractNativeCell

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.cassandra.db.composites.Composite

      `Composite.EOC`

    - ### Nested classes/interfaces inherited from interface org.apache.cassandra.db.OnDiskAtom

      `OnDiskAtom.Serializer, OnDiskAtom.SerializerForWriting`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.cassandra.db.Cell

      `MAX_NAME_LENGTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NativeCell(NativeAllocator allocator, OpOrder.Group writeOp, Cell copyOf)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Cell` | `localCopy(CFMetaData metadata, AbstractAllocator allocator)`
    `Cell` | `localCopy(CFMetaData metadata, MemtableAllocator allocator, OpOrder.Group opGroup)`
    `CellName` | `name()`
    `long` | `timestamp()` For a standard column, this is the same as timestamp().
    `long` | `unsharedHeapSize()`
    `long` | `unsharedHeapSizeExcludingData()`
    `void` | `updateDigest(java.security.MessageDigest digest)`

    - ### Methods inherited from class org.apache.cassandra.db.AbstractNativeCell

      `clusteringSize, collectionElement, compareTo, compareToSimple, construct, copy, cql3ColumnName, dataSize, end, eoc, equals, equals, get, getByte, getByteBuffer, getBytes, getInt, getLong, getShort, internalSize, isCollectionCell, isEmpty, isPrefixOf, isSameCQL3RowAs, isStatic, maxTimestamp, minTimestamp, postfixSize, setByte, setBytes, setInt, setLong, setShort, size, sizeOf, slice, start, toByteBuffer, updateWithName, updateWithValue, value, withEOC, withUpdatedName, withUpdatedTimestamp, withUpdatedTimestampAndLocalDeletionTime, writeComponentTo, writeMemoryTo`

    - ### Methods inherited from class org.apache.cassandra.db.AbstractCell

      `cellDataSize, create, diff, diffCounter, equals, getLocalDeletionTime, getString, hashCode, isLive, isLive, onDiskIterator, reconcile, reconcileCounter, serializationFlags, serializedSize, validateFields, validateName`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NativeCell

          public NativeCell(NativeAllocator allocator,
                            OpOrder.Group writeOp,
                            Cell copyOf)

  - ### Method Detail

    - #### name

          public CellName name()

    - #### timestamp

          public long timestamp()

      Description copied from interface: `OnDiskAtom`
      For a standard column, this is the same as timestamp(). For a super column, this is the min/max column timestamp of the sub columns.

    - #### localCopy

          public Cell localCopy(CFMetaData metadata,
                                AbstractAllocator allocator)

    - #### localCopy

          public Cell localCopy(CFMetaData metadata,
                                MemtableAllocator allocator,
                                OpOrder.Group opGroup)

    - #### updateDigest

          public void updateDigest(java.security.MessageDigest digest)

      Specified by:
        `updateDigest` in interface `OnDiskAtom`
      Overrides:
        `updateDigest` in class `AbstractCell`

    - #### unsharedHeapSizeExcludingData

          public long unsharedHeapSizeExcludingData()

    - #### unsharedHeapSize

          public long unsharedHeapSize()

      Returns:
        the amount of on-heap memory retained by the object that might be reclaimed if the object were reclaimed, i.e. it should try to exclude globally cached data where possible, or counting portions of arrays that are referenced by the object but used by other objects only (e.g. slabbed byte-buffers), etc.

Copyright © 2018 The Apache Software Foundation